
//========================================================================================
//
//	File:				FWProfiler.h
//	Release Version:	$ ODF 2 $ 
//
//	Copyright:	(c) 1993-1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPROFILER_H
#define FWPROFILER_H

#ifndef __TYPES__
#include <Types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

short FW_ProfilerGetStatus();
	// get the on/off status of the profiler
	
void FW_ProfilerSetStatus(short on);
	// set the on/off status of the profiler

void FW_ProfilerSetDumpFile(ConstStr255Param newPath);
	// note: newPath is a length-prefixed pascal string
	// optionally specify the file to output subsequent dumps
	// into. If no file is specified, data will be dumped
	// into a file called "ODFProfiler Dump" at the root of
	// the boot volume. If the file already exists, a number
	// is automatically appended and incremented.
	
void FW_ProfilerUseDefaultDumpFile();
	// reset the dump file to its default value

OSErr FW_ProfilerDump();
	// dump the profiler buffer into the current dump file.
	// this does not clear the profile information.
	
void FW_ProfilerClear();
	// clear the profile buffer. this does not affect
	// the on/off status of the profiler. 
	
/* 
	Note to thread users: The ODF interface to CW profiling does
	not provide explicit support for threads. If you need to
	interact with the profiler's thread interface, include
	the Metrowerks header "Profiler.h" and call the thread
	methods directly. The thread-related interfaces are exported
	from the ODFCWProfilerLib to enable this.
*/

#ifdef __cplusplus
}
#endif

#endif